//
// PropertyScore.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PropertyScore: Codable, JSONEncodable, Hashable {

    public var categoryScores: PropertyScoreCategoryScores?
    public var inferenceScores: PropertyScoreInferenceScores?
    public var mediaCountScores: PropertyScoreMediaCountScores?
    public var categoryPhotosPresent: PropertyScoreCategoryPhotosPresent?
    public var finalCategoryScores: PropertyScoreFinalCategoryScores?
    public var bonusScore: Score?
    public var finalScore: Double?

    public init(categoryScores: PropertyScoreCategoryScores? = nil, inferenceScores: PropertyScoreInferenceScores? = nil, mediaCountScores: PropertyScoreMediaCountScores? = nil, categoryPhotosPresent: PropertyScoreCategoryPhotosPresent? = nil, finalCategoryScores: PropertyScoreFinalCategoryScores? = nil, bonusScore: Score? = nil, finalScore: Double? = nil) {
        self.categoryScores = categoryScores
        self.inferenceScores = inferenceScores
        self.mediaCountScores = mediaCountScores
        self.categoryPhotosPresent = categoryPhotosPresent
        self.finalCategoryScores = finalCategoryScores
        self.bonusScore = bonusScore
        self.finalScore = finalScore
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case categoryScores
        case inferenceScores
        case mediaCountScores
        case categoryPhotosPresent
        case finalCategoryScores
        case bonusScore
        case finalScore
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(categoryScores, forKey: .categoryScores)
        try container.encodeIfPresent(inferenceScores, forKey: .inferenceScores)
        try container.encodeIfPresent(mediaCountScores, forKey: .mediaCountScores)
        try container.encodeIfPresent(categoryPhotosPresent, forKey: .categoryPhotosPresent)
        try container.encodeIfPresent(finalCategoryScores, forKey: .finalCategoryScores)
        try container.encodeIfPresent(bonusScore, forKey: .bonusScore)
        try container.encodeIfPresent(finalScore, forKey: .finalScore)
    }
}

